// Inv.c (C) 2000 Jay Cook
// Main functions, runs the game
// notes: can there be extra guys after the first 1000?
// notes: need to find out how mother ship score is done
// notes: need to find out how mother ship apearance is figured(when it apears)
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <mem.h>
#include <alloc.h>
#include <assert.h>
#include "control.h"
#define InvadeVer ".87"
#define InvadeDate "09-21-00"

#define MaxAliens 56     // How many aliens are on deck
#define MaxSprite 22     // How different sprites in memory
#define LimitLeft 33     // far left limit of screen for guy
#define AlienRight 220   // far right limit for aliens
#define LimitRight (AlienRight-30)-8 // far right limit for player
#define FireSpace 38    // space between alien bullets
#define MaxShips 2       // how many ships you start with
#define ShieldYPlace 148 // The Y coord of the shields
#define AlienDrop 8     // how far alien drops when hit side of screen
#define FireMaxTime 30     // how long until alien will fire again
#define AlienSpace 16    // the spacing between aliens in grid
#define MCMax 120        // how long dead mother ship stays on screen
#define Ship1st 1000     // how many points needed to get 1st free ship
#define Ship2nd 3000     // how many additional points needed to get free ships

JOYSTICK_STATE JsState;
int JsThresholdUp,JsThresholdDown,JsThresholdLeft,JsThresholdRight, JoyOn;


void GetSprites();
void GetKeys();
void DrawGuy();   // controls your ship
void MoveAlien(); // Does movements for alien
void QuitDos();   // clears up everything and quits
void FireGun();   // controls your fire
void StartAlien(); // sets up alien stack
void FireAlien();  // controls alien fire
void YouDie();  // Death of your guy
void UpdateScore(); // Draws new score
void UpdateShips(); // Draws how many ships you have
void SetJoy1();   // sets up joystick
void JoySwap();   // turns joy on or off
void PauseGame(); // Pauses the game
void WaitKeyReturn(); // waits for a key or joypress
void DrawShields(); // draws player's shields
void DoMotherShip(); // Does the actions for mystery ship
void CheckHightScore(); // checks to see if there is new high score
void DrawHighScore();   // draws high score
void CheckHighScore(); // checks to see if there is a new high score
void BGames();          // what it shows between games
void WaitKeyReturn2();  // clears keyboard buffer

typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;
char TextNumber[20];
int GameState,k, GuyX, GuyY, GuyXOld, GuyYOld, TotalAlien, CurrentAlien;
int FireState, GunX, GunY,r, Switch[MaxAliens], SNum, MoveAl,t,kk, YourScore;
int Alien[MaxAliens],ALevel, AlienHit, AlHit, AGun, AlienStartY;
int AlienX[MaxAliens],AlienY[MaxAliens], TotalShips, NewCurrent;
int AlienXOld[MaxAliens], AlienYOld[MaxAliens], FireTimer;
int AlienGun[3], AlienGunX[3], AlienGunY[3], ShipCnt, MShipAction;
int MShipX, MShipMove, MCounter, MShipStep;
int HighScore, k2, AlienRowCnt;

struct ISprite
 {  // for Object list
//  int Sprite1[69];
 char far *Sprite1;
 } Sprites[MaxSprite];

//////////////////////////
void main()
//////////////////////////
{
 randomize();
 set_mode(0x13);
 SetBuffer();
 InitFont();
 GetSprites();
 SetJoy1();                         // sets up joystick
 if ((JsState.JsMask & 0x3) != 0)  JoyOn=1; //Joystick found
 else   JoyOn=0; // Joystick not found
 SetButtonKeysMode();            // sets keyboard to buttons
 HighScore=1000;
 CLS();
 DrawBlock(0,180,320,20,8);
 DrawBlock(LimitLeft-2,180,2,4,9);
 DrawBlock(LimitRight+8,180,2,4,9);
 DrawBlock(223,0,97,200,30);
 GFont(31,2,"Imitator"); GFont(31,3,"Invaders");
 GFont(29,6,"Hi-Score:");
 GFont(29,9,"Score:");
 UpdateScore(0);
 DrawHighScore();
 GFont(31,24,"Jay Cook");
 BGames();
 StartNewGame:
 GameState=1;
 FireState=0;
 TotalShips=MaxShips;
 GunX=0; GunY=0;
 GuyX=150; GuyY=172;
 GuyXOld=GuyX; GuyYOld=GuyY;
 MShipAction=1;
 ShipCnt=-1;
 ALevel=1;
// debug
// ALevel=15;
 StartAlien();
 DrawBlock(0,0,223,180,0);
 YourScore=0;
 UpdateScore(0);
 DrawHighScore();
 GFont(32,12,"x");SpriteDraw(240,88,Sprites[1].Sprite1);
 GFont(10,10,"Get Ready!"); for(k=0;k<60;k++) { WaitVR(); } DrawBlock(71,72,80,8,0);
 UpdateShips();
 DrawShields();
 do
 {
  GetKeys();
  FireGun();
  MoveAlien();
  DrawGuy();
  FireAlien();
  WaitVR();
 } while(GameState!=0);
 BGames();
 goto StartNewGame;
}

///////////////////////
void WaitKeyReturn2()
///////////////////////
{ // Waits for key to be hit
 SetNormalKeysMode();            // sets keyboard back to normal
 SetButtonKeysMode();            // sets keyboard back to fast
}

////////////////////////
void BGames()
////////////////////////
{
  WaitKeyReturn2();
  GameState=2;
  FireState=0;
  DrawBlock(0,0,223,180,0);
  GFont(13,3,"Play");
  GFont(6,5,"Imitator Invaders");
  GFont(4,9,"*Score Advance Table*");
  GFont(11,11,"- ? Mystery");
  GFont(11,13,"- 30 Points");
  GFont(11,15,"- 20 Points");
  GFont(11,17,"- 10 Points");
  SpriteDraw(56,80,Sprites[16].Sprite1);
  SpriteDraw(64,80,Sprites[17].Sprite1);
  WaitVR();
  k=29;
  do
  {
   GetKeys();
   k++;
   if (GameState==0) QuitDos(0,"None", "None");
   if (k==30)
   { // animates aliens
     SpritePut(60,96,Sprites[3].Sprite1);
     SpritePut(60,112,Sprites[5].Sprite1);
     SpritePut(60,128,Sprites[7].Sprite1);
     GFont(7,20,"Hit Fire to Start");
   }
   if (k==60)
   { // animates aliens
     SpritePut(60,96,Sprites[4].Sprite1);
     SpritePut(60,112,Sprites[6].Sprite1);
     SpritePut(60,128,Sprites[8].Sprite1);
     DrawBlock(48,152,140,8,0);
     k=0;
   }
   WaitVR();
  } while(FireState==0);
  GameState=1;
}

//////////////////////////
void StartAlien()
//////////////////////////
{  // Sets up Alien Stack
 MoveAl=2;
 ALevel++;
 AlienHit=0;
 if(ALevel>10)ALevel=10;
 CurrentAlien=MaxAliens;
 AlienStartY=8*ALevel;
 for(k=0;k<3;k++){ AlienGunY[k]=172; AlienGunX[k]=0; }
 for(k=0;k<12;k++)
 { Alien[k]=1; AlienY[k]=20+AlienStartY; AlienX[k]=(k*AlienSpace); Switch[k]=0;}
 for(k=12;k<23;k++)
 { Alien[k]=2; AlienY[k]=36+AlienStartY; AlienX[k]=((k-11)*AlienSpace);Switch[k]=0;}
 for(k=23;k<34;k++)
 { Alien[k]=2; AlienY[k]=52+AlienStartY; AlienX[k]=((k-22)*AlienSpace);Switch[k]=0;}
 for(k=34;k<45;k++)
 { Alien[k]=3; AlienY[k]=68+AlienStartY; AlienX[k]=((k-33)*AlienSpace);Switch[k]=0;}
 for(k=45;k<56;k++)
 { Alien[k]=3; AlienY[k]=84+AlienStartY; AlienX[k]=((k-44)*AlienSpace);Switch[k]=0;}
 for(r=0;r<MaxAliens;r++)
 { AlienXOld[r]=AlienX[r];  AlienYOld[r]=AlienY[r];}
 TotalAlien=0; for(k2=1;k2<MaxAliens-1;k2++){ if(Alien[k2]>0) TotalAlien++; }
}

//////////////////////////
void DrawShields()
//////////////////////////
{// Draw Shields
 DrawBlock(20,ShieldYPlace,180,16,0);
 if(ALevel < 7)
 { // if aliens get down to a certain level, then don't draw shields
  for(k=0;k<4;k++)
  {
    SpritePut(20+(k*40)+20,ShieldYPlace,Sprites[9].Sprite1);
    SpritePut(28+(k*40)+20,ShieldYPlace,Sprites[11].Sprite1);
    SpritePut(36+(k*40)+20,ShieldYPlace,Sprites[10].Sprite1);
    SpritePut(20+(k*40)+20,ShieldYPlace+8,Sprites[11].Sprite1);
    SpritePut(28+(k*40)+20,ShieldYPlace+8,Sprites[12].Sprite1);
    SpritePut(36+(k*40)+20,ShieldYPlace+8,Sprites[11].Sprite1);
  }
 }
}

//////////////////////////
void GetSprites()
//////////////////////////
{  // Sets up Font info in mem
 int SpriteR,k; // 8x8(64 bytes -1) font size
 SpriteR = 65 * sizeof(char);
 for(k=0;k<MaxSprite;k++)
  Sprites[k].Sprite1 = farmalloc(SpriteR);

 SpriteGet(1,1,Sprites[0].Sprite1);
 LoadBMP("inv.gfx");      // Loads graphics
 SpriteGet(1,1,Sprites[1].Sprite1);  // Your Ship
 SpriteGet(10,1,Sprites[2].Sprite1); // Explosion
 SpriteGet(1,10,Sprites[3].Sprite1); // Alien 1
 SpriteGet(10,10,Sprites[4].Sprite1); 
 SpriteGet(19,10,Sprites[5].Sprite1); // Alien 2
 SpriteGet(28,10,Sprites[6].Sprite1);
 SpriteGet(37,10,Sprites[7].Sprite1); // Alien 3
 SpriteGet(46,10,Sprites[8].Sprite1);
 SpriteGet(19,1,Sprites[9].Sprite1); // Left side of shield
 SpriteGet(28,1,Sprites[10].Sprite1); // Right side of shield
 SpriteGet(37,1,Sprites[11].Sprite1); // Block for Shield
 SpriteGet(46,1,Sprites[12].Sprite1); // Middle of shield
 SpriteGet(55,1,Sprites[13].Sprite1); // death scene 1
 SpriteGet(64,1,Sprites[14].Sprite1); // death scene 2
 SpriteGet(73,1,Sprites[15].Sprite1); // shield decay
 SpriteGet(82,1,Sprites[16].Sprite1); // Mother ship left side
 SpriteGet(91,1,Sprites[17].Sprite1); // Mother ship right side
 SpriteGet(100,1,Sprites[18].Sprite1); // 0 for score with mother ship
 SpriteGet(109,1,Sprites[19].Sprite1); // 5 for score with mother ship
 SpriteGet(118,1,Sprites[20].Sprite1); // 3 for score with mother ship
 SpriteGet(127,1,Sprites[21].Sprite1); // 1 for score with mother ship
 GetFont();
}

//////////////////////////
void DoMotherShip()
//////////////////////////
{
 int RandShip;
 switch(MShipAction)
 {
  case 1:
  { // if the mothership is not active
    RandShip=(rand() % 700);
//    RandShip=(rand() % 10);
    if(RandShip==1)
    { // if random number matches up then do mother ship
     MShipAction=2;
     MCounter=MCMax;
     if(MShipMove==-1) { MShipMove=1; MShipX=5; }
     else { MShipMove=-1; MShipX=200; }
    }
  } break;
  case 2:
  { // if the mothership is active
   // move mother ship
   if(MShipStep >0) { MShipX=MShipX+MShipMove; MShipStep=0; }
   else MShipStep=1;
   SpritePut(MShipX-MShipMove,10,Sprites[0].Sprite1);
   SpritePut(MShipX-MShipMove+8,10,Sprites[0].Sprite1);
   SpritePut(MShipX+8,10,Sprites[17].Sprite1);
   SpritePut(MShipX,10,Sprites[16].Sprite1);
   if(MShipX< 5 || MShipX> 200) 
   {     // if mother ship hits side of screen, then erase it
     SpritePut(MShipX,10,Sprites[0].Sprite1);
     SpritePut(MShipX+8,10,Sprites[0].Sprite1);
     MShipAction=1;
   }
  } break;
  case 3: 
  { // mother ship is hit
   if(MCounter==MCMax)
   { // erase mother ship and show debris
    SpritePut(MShipX,10,Sprites[0].Sprite1);
    SpritePut(MShipX+8,10,Sprites[0].Sprite1);
    // switch directions of ship after it is dead
    RandShip=(rand() % 4);      // random number done for score
    switch(RandShip)  
    {
     case 0:{
     SpritePut(MShipX,10,Sprites[19].Sprite1); SpritePut(MShipX+8,10,Sprites[18].Sprite1);
     UpdateScore(50); } break;
     case 1:{
     SpritePut(MShipX,10,Sprites[21].Sprite1); SpritePut(MShipX+8,10,Sprites[18].Sprite1);
     SpritePut(MShipX+16,10,Sprites[18].Sprite1); UpdateScore(100); } break;
     case 2:{
     SpritePut(MShipX,10,Sprites[21].Sprite1); SpritePut(MShipX+8,10,Sprites[19].Sprite1);
     SpritePut(MShipX+16,10,Sprites[18].Sprite1); UpdateScore(150); } break;
     case 3:{
     SpritePut(MShipX,10,Sprites[20].Sprite1); SpritePut(MShipX+8,10,Sprites[18].Sprite1);
     SpritePut(MShipX+16,10,Sprites[18].Sprite1); UpdateScore(300); } break;
    }
   }
   MCounter--;
   if(MCounter==0)
   {  // wait until MCounter runs out to erase debris from mothership
    MShipAction=1;
    SpritePut(MShipX,10,Sprites[0].Sprite1);
    SpritePut(MShipX+8,10,Sprites[0].Sprite1);
    SpritePut(MShipX+16,10,Sprites[0].Sprite1);
   }
  } break;
 }
}

//////////////////////////
void FireAlien()
//////////////////////////
{
 for(k=0;k<3;k++)
 {
  if(AlienGun[k]==0 && AlienHit==0 && FireTimer<1 && TotalAlien > 0)
  {
    AlienRowCnt=0;
    FireTimer=FireMaxTime;  // reset fire timer
    RandAlien: // gets random number for alien
        // gives it 5 tries and if it can't find an alive alien it will leave loop
     AlienRowCnt++; if(AlienRowCnt>5) goto ExitFireLoop;
     kk=55-(rand() % 10);  // random fire pos
    Check1: // if the whole line is empty pick another
     if(kk<1)goto RandAlien;
     if(Alien[kk]==0){ kk=kk-11; goto Check1; }
     else   // give alien fire a position
     { 
       if(AlienY[kk] < 163)
       { AlienGun[k]=1; AlienGunX[k]=AlienX[kk]+4; AlienGunY[k]=AlienY[kk]+8; }
     }
   ExitFireLoop:
  }
  if(AlienGun[k]==1)
  {
   DrawLine(AlienGunX[k],AlienGunY[k],8,0);
   AlienGunY[k]++;
   if(AlienGunY[k]>172) AlienGun[k]=0;
   else DrawLine(AlienGunX[k],AlienGunY[k],8,12);
   if(AlienGunY[k]+8 > GuyY && AlienGunY[k] < GuyY+8 && AlienGunX[k] <= GuyX+8 && AlienGunX[k] >= GuyX)
   { YouDie(); } // if you collide with fire, goto death scene
   if(AlienGunY[k] > 141 && CheckPixel(AlienGunX[k],AlienGunY[k]+8)==1)
   { // check to see if shields are hit
    AlienGun[k]=0; DrawLine(AlienGunX[k], AlienGunY[k],8,0);
    SpriteDraw(AlienGunX[k]-2,AlienGunY[k]+7,Sprites[15].Sprite1);
   }
  }
 }
 FireTimer--; // timer for delay in alien bullets
}

//////////////////////////
void GetKeys()
//////////////////////////
{
  if (GetKeyState(KEY_LEFT)) { GuyXOld=GuyX; GuyX--; };
  if (GetKeyState(KEY_RIGHT)) { GuyXOld=GuyX; GuyX++; };
  if (GetKeyState(KEY_P)) PauseGame();
  if (GetKeyState(KEY_J)) JoySwap();
  if (GetKeyState(KEY_SPACE)) { if(FireState==0)FireState=2; }
  if (GetKeyState(KEY_ESC)) { GameState=0; };

  if ((JsState.JsMask & 0x3) != 0 && JoyOn==1)
   {
     ReadJoysticks(&JsState);
     if (JsState.JsAxisAX < JsThresholdLeft){ GuyXOld=GuyX; GuyX--; };
     if (JsState.JsAxisAX > JsThresholdRight){ GuyXOld=GuyX; GuyX++; };
     if (JsState.JsButtonA1>0) { if(FireState==0)FireState=2; }
     if (JsState.JsButtonB2>0) { PauseGame(); }
   }
}

//////////////////////////
void DrawGuy()
//////////////////////////
{
 // Checks limits on screen
 if(GuyX<LimitLeft)GuyX=GuyXOld;
 if(GuyX>LimitRight)GuyX=GuyXOld;
 // Draws player
 SpritePut(GuyXOld,GuyYOld,Sprites[0].Sprite1);
 SpriteDraw(GuyX,GuyY,Sprites[1].Sprite1); 
}

//////////////////////////
void MoveAlien()
//////////////////////////
{ // the movement and animation of the aliens
 switch(AlienHit)
 {
 case 0:
 {   // if an alien hasn't been shot, then keep moving
  CheckAlien:
  CurrentAlien--;
      // if at the top of alien stack go to the bottom 
  if(CurrentAlien==0) CurrentAlien=MaxAliens-1;
      // if the current alien is dead, go to the next one
  if(Alien[CurrentAlien]==0) goto CheckAlien;

  if(Alien[CurrentAlien]==1 || Alien[CurrentAlien]==2 || Alien[CurrentAlien]==3)
  {
      // Erases where alien was last at
   SpritePut(AlienXOld[CurrentAlien],AlienYOld[CurrentAlien],Sprites[0].Sprite1);
        // Moves Alien
   AlienX[CurrentAlien]=AlienX[CurrentAlien]+MoveAl;

   ////// if one alien hits the edge of the screen drop all down a level
   if(AlienX[CurrentAlien]>AlienRight-10 || AlienX[CurrentAlien]<5 )
   { // drops all the aliens down a notch and switches direction
    for(t=0;t<MaxAliens;t++) if(Alien[t]>0) AlienY[t]=AlienY[t]+AlienDrop;
    for(t=CurrentAlien;t<MaxAliens;t++)
     { if(Switch[t]==0)Switch[t]=1; else Switch[t]=0;}
      // lines up the rest of the aliens
    for(t=CurrentAlien;t<MaxAliens;t++) if(Alien[t]>0) AlienX[t]=AlienX[t]-MoveAl;
     // change direction
    if(MoveAl==2)MoveAl=-2;  else MoveAl=2;
    NewCurrent=1;    // tells computer to start movement with 1st alien
   }
      // Remember the last position of alien so it can be erased
   AlienXOld[CurrentAlien]=AlienX[CurrentAlien];  AlienYOld[CurrentAlien]=AlienY[CurrentAlien];

       // if alien hits the bottom of the screen "Game over man!"
  if(AlienY[CurrentAlien]>=172)
   { SpritePut(GuyX,GuyY,Sprites[0].Sprite1);GameState=0; }

 //// draws alien
   // Change animation
 if(Switch[CurrentAlien]==0)Switch[CurrentAlien]=1; else Switch[CurrentAlien]=0;  
  // SpriteNumber for Alien (if still alive)
 if(Alien[CurrentAlien]>0 && Alien[CurrentAlien]<4)
  { SNum=(Alien[CurrentAlien]*2)+1+Switch[CurrentAlien];}
  // draws alien sprite
  SpriteDraw(AlienX[CurrentAlien],AlienY[CurrentAlien],Sprites[SNum].Sprite1);

  if(NewCurrent==1){ CurrentAlien=MaxAliens; NewCurrent=0; }
  }
 } break;
 case 1:
 {  // if an alien has been shot, then pause
  AlHit--;
    // if pause is over, then erase explosion sprite and allow fire again
  if(AlHit==0)
  {
    AlienHit=0;
    FireState=0;
    SpritePut(GunX,GunY,Sprites[0].Sprite1);
   // counts how many aliens are alive
   TotalAlien=0; for(k=1;k<MaxAliens-1;k++){ if(Alien[k]>0) TotalAlien++; }
   // if all aliens are dead, then start a new
   if(TotalAlien==0) { AlHit=60; AlienHit=2;}
  }
 } break;
  case 2:
  { // if all aliens are dead, set up next wave
   AlHit--;
   if(AlHit==0)
   { AlienHit=0; StartAlien(); DrawShields();
     for(k=0;k<3;k++)
     { // clear alien bullets
      AlienGun[k]=0; DrawLine(AlienGunX[k],AlienGunY[k],8,0); AlienGunY[k]=172; AlienGunX[k]=1;
     }
   }
  } break;
 }
  DoMotherShip();
}

//////////////////////////
void FireGun()
//////////////////////////
{ 
 if(FireState==1)
 {// If bullet is in motion, continue it
  DrawLine(GunX, GunY,8,0);
  GunY=GunY-3;
  DrawLine(GunX, GunY,8,15);
  if(GunY<10)
  { // if it hits the top of the screen
   FireState=0;
   DrawLine(GunX, GunY,8,0);
  }
    // kills mothership
  if(GunX >= MShipX && GunX <= MShipX+16 && GunY+8 >= 10 && GunY <= 18)
   { MShipAction=3; FireState=0; DrawLine(GunX, GunY,8,0); }
    // checks to see if shield is hit
  if(GunY > 149 && CheckPixel(GunX,GunY-1)==1)
   { FireState=0; DrawLine(GunX, GunY,8,0); SpriteDraw(GunX-2,GunY-2,Sprites[15].Sprite1);}
  for(k=0;k<3;k++)
  {  // checks to see if you hit an alien bullet
   if(AlienGunX[k]==GunX && AlienGunY[k] < GunY+8 && AlienGunY[k]+8 > GunY)
   { 
    AlienGun[k]=0;
    DrawLine(AlienGunX[k],AlienGunY[k],8,0);
    DrawLine(GunX, GunY,8,0);
    AlienGunY[k]=172; AlienGunX[k]=1;
    FireState=0;
     return;
   }
  }
  for(k=0;k<MaxAliens;k++)
  { // check colision with alien
   if(Alien[k]>0 && Alien[k]<4 && (AlienX[k]<=GunX && AlienX[k]+8>=GunX) && (AlienY[k]<=GunY+8 && AlienY[k]+8>=GunY))
   {
    AlienHit=1;
    AlHit=20;
    if(Alien[k]==1)UpdateScore(30);
    if(Alien[k]==2)UpdateScore(20);
    if(Alien[k]==3)UpdateScore(10);
    FireState=3;
    DrawLine(GunX, GunY,8,0);
    GunX=AlienXOld[k]; GunY=AlienYOld[k];
    Alien[k]=0;
   }
  }
 }
 if(FireState==2)
 { // when bullet is first shot
  FireState=1;
  GunX=GuyX+4;
  GunY=166;
 }
 if(FireState==3)
 { // if you hit an alien, show explosion
  SpritePut(GunX,GunY,Sprites[2].Sprite1);
 }
}

//////////////////////////
void YouDie()
//////////////////////////
{
 for(k=0;k<3;k++)
 { // clear alien bullets
  AlienGun[k]=0;
  DrawLine(AlienGunX[k],AlienGunY[k],8,0);
  AlienGunY[k]=172; AlienGunX[k]=1;
 }
 // erase your bullet
 DrawLine(GunX, GunY,8,0);

 for(r=0;r<4;r++)
 {// does death animation
   for(k=0;k<10;k++)
   { SpritePut(GuyX,GuyY,Sprites[13].Sprite1); WaitVR(); } 
   for(k=0;k<10;k++)
   { SpritePut(GuyX,GuyY,Sprites[14].Sprite1); WaitVR(); } 
 }
 SpritePut(GuyX,GuyY,Sprites[0].Sprite1); 
 TotalShips--;
 UpdateShips();
 if(TotalShips<0)
 {
  GameState=0;
  CheckHighScore();
 }
}

//////////////////////////
void UpdateShips()
//////////////////////////
{
 int TShips;
 TShips=TotalShips; if(TShips<0)TShips=0;
 itoa(TShips,TextNumber,10);
 DrawBlock(256,88,16,8,30); GFont(33,12,TextNumber);
}

//////////////////////////
void CheckHighScore()
//////////////////////////
{
 if(YourScore>HighScore)
 {
  HighScore=YourScore;
  DrawHighScore();
  GFont(7,10,"New High Score!!");
  for(k=0;k<(60*4);k++) { WaitVR(); }
  WaitVR();
 }
}

//////////////////////////
void DrawHighScore()
//////////////////////////
{
 itoa(HighScore,TextNumber,10);
 DrawBlock(224,48,88,8,31); GFont(29,7,TextNumber);
}

//////////////////////////
void UpdateScore(int AddScore)
//////////////////////////
{
       // if you get 1000pts, add a ship
 YourScore=YourScore+AddScore;
 // first 1000 points gets a ship
 if(ShipCnt==-1)
   { if(YourScore>=Ship1st){ ShipCnt=0; TotalShips++; UpdateShips(); } }
 else
 {  // for every next 3000 points, add a ship
  ShipCnt=ShipCnt+AddScore;
  if(ShipCnt >= Ship2nd) { ShipCnt=ShipCnt-Ship2nd; TotalShips++; UpdateShips(); }
 }
       // draw score
 itoa(YourScore,TextNumber,10);
 DrawBlock(224,72,88,8,31); GFont(29,10,TextNumber);
}

//////////////////////////
void FreeSprites()
//////////////////////////
{
 for(k=0;k<MaxSprite;k++)
   farfree(Sprites[k].Sprite1);
}

//////////////////////////
void QuitDos(int ErrNum, char ErrMsg[40], char FileNam1[11])
//////////////////////////
{  // Quits back to dos, sets all stuff back up, prints an error message
 SetNormalKeysMode();            // sets keyboard back to normal
 FreeFont();
 FreeSprites();
 freemem;                        // frees memory
 set_mode(0x03);                 /* set the video mode back to text mode. */
 if (ErrNum == 0)
 { // Prints out exit screen
  //textcolor(15);
  printf("\n\n Imitator Invaders\n ------------------");
  printf("\n   Compiled with: Turbo C++ 3.0");
  printf("\n   Date compiled: %s",InvadeDate);
  printf("\n   version %s", InvadeVer);
  printf("\n   Copyright 2000 Jay Cook");
  printf("\n\n   Homepage: ziel.tripod.com");
  printf("\n   Email:    jaycook1@juno.com");
  printf("\n\n");
 }
 if (ErrNum == 1)
 {  // Prints error message if it quits bad
  printf("\n **** ERROR ****");
  printf("\nError Message: %s\n",ErrMsg);
  printf("Error file: %s\n\n",FileNam1);
 }
 exit(1);
}

////////////////////////
void CalJoy
//////////////////////////
(
 JOYSTICK_STATE * JsState,
 unsigned int * Xmin,
 unsigned int * Ymin,
 unsigned int * Xmid,
 unsigned int * Ymid,
 unsigned int * Xmax,
 unsigned int * Ymax
)

{
  assert(JsState != NULL);
  assert(Xmin != NULL);
  assert(Ymin != NULL);
  assert(Xmid != NULL);
  assert(Ymid != NULL);
  assert(Xmax != NULL);
  assert(Ymax != NULL);
  /* read midpoint values */
  ReadJoysticks(JsState);
  *Xmid = JsState->JsAxisAX;
  *Ymid = JsState->JsAxisAY;
  /* assume min coordinate 0,0 and max is twice midpoint */
  *Xmin = *Ymin = 0;
  *Xmax = 2 * *Xmid;
  *Ymax = 2 * *Ymid;
}

////////////////////////
void SetJoy1()
//////////////////////////
{
 SenseJoysticks(&JsState); // figures out if any josysticks present
 if ((JsState.JsMask & 0x3) != 0)
 {
 unsigned int Xmin, Xmid, Xmax;
 unsigned int Ymin, Ymid, Ymax;
 CalJoy (&JsState, &Xmin, &Ymin, &Xmid, &Ymid, &Xmax, &Ymax);
  JsThresholdUp      = Ymax / 3;
  JsThresholdDown    = (Ymax * 2) /3;
  JsThresholdLeft    = Xmax /3;
  JsThresholdRight   = (Xmax * 2) /3;
 }
}

////////////////////////
void JoySwap()
//////////////////////////
{
 if(JoyOn==0) { JoyOn=1; GFont(1,1,"Joystick On");}
 else { JoyOn=0; GFont(1,1,"JoyStick Off");}
 for(k=0;k<60;k++) { WaitVR(); }
 DrawBlock(0,0,100,8,0);
}

////////////////////////
void PauseGame()
//////////////////////////
{  // Pauses game
 if(GameState==1)
 {
  GFont(1,1,"Pause");
  WaitVR();
  // Clear keys, wait for keypress and release
   WaitKeyReturn();
  DrawBlock(0,0,100,8,0);
 }
}

///////////////////////
void WaitKeyReturn()
///////////////////////
{ // Waits for key to be hit
 int Key1, eloop;
 SetNormalKeysMode();            // sets keyboard back to normal
 eloop=0;

 do // clears up joystick
 {
  if (JoyOn==0) eloop=1;
  if ((JsState.JsMask & 0x3) != 0 && JoyOn==1)
  {
    ReadJoysticks(&JsState);
    if (JsState.JsButtonA1==0) eloop=1;
  }
 } while(eloop!=1);
 eloop=0;
 do {
  if(kbhit())
  {
   Key1=getch();
   if( Key1==13 || Key1==27 || (45 <= Key1 && Key1 <= 126) ) eloop=1;
  }
  if ((JsState.JsMask & 0x3) != 0 && JoyOn==1)
  {
    ReadJoysticks(&JsState);
    if (JsState.JsButtonA1>0) eloop=1;
  }
 } while(eloop!=1);
 SetButtonKeysMode();            // sets keyboard back to fast
}
